/*  double_list_main_object - object and methods for double list - hpaned.
    Copyright (C) 2004  Daniele F.

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA  */

/* For bugs or infos please contact me <geekgnele@tin.it> */


#ifndef _DOUBLE_LIST_MAIN_OBJECT_H
#define _DOUBLE_LIST_MAIN_OBJECT_H

G_BEGIN_DECLS
#define DOUBLE_LIST_MAIN_TYPE	(double_list_main_get_type())
#define DOUBLE_LIST_MAIN(obj) (G_TYPE_CHECK_INSTANCE_CAST((obj), DOUBLE_LIST_MAIN_TYPE, DoubleListMain))
#define DOUBLE_LIST_MAIN_CLASS(obj) (G_TYPE_CHECK_CLASS_CAST((obj), DOUBLE_LIST_MAIN_TYPE, DoubleListMainClass))

#define GCONF_PATH_GLOBAL	"/apps/glsof/global/"

typedef struct {
    GObjectClass parent_class;
} DoubleListMainClass;

typedef struct {
    GObject parent;

    GtkWidget *vbox_paned;
	GtkTreeStore *treestore;
	
	/* queries */
	GSList *queries;
	GPtrArray *array_queries;	/* array of double_list_process_objects */
	guint selected_query;
	guint selected_elem;
} DoubleListMain;

/* external functions */
GObject *double_list_main_new(void);
GType double_list_main_get_type(void);

/* various functions */
void double_list_main_set_status_columns(DoubleListMain *, gint);
void double_list_main_add_row(DoubleListMain *, guint);

/* query functions */
void double_list_main_remove_query (DoubleListMain *, GtkTreePath *, guint);
void double_list_main_refresh_query_full(DoubleListMain *);
void double_list_main_refresh_query(DoubleListMain *, guint);
void double_list_main_add_query (DoubleListMain *, const gchar *);
gboolean double_list_main_add_query_check (DoubleListMain *, const gchar *);

/* getter functions */
gboolean double_list_main_is_there_a_row (DoubleListMain *);
guint double_list_main_get_number_processes_for_query (DoubleListMain *, guint);
guint double_list_main_get_number_lines_process_for_query (DoubleListMain *, guint, guint);
guint double_list_main_get_number_queries (DoubleListMain *);
gchar *double_list_main_get_name_query (DoubleListMain *, guint);
gchar *double_list_main_get_name_process_for_query (DoubleListMain *, guint, guint);
GtkListStore *double_list_main_get_process_liststore_for_query (DoubleListMain *, guint, guint);
GtkTreeView *double_list_main_get_process_treeview_for_query (DoubleListMain *, guint, guint);

/* select functions */
void double_list_main_select_process_row_in_query (DoubleListMain *, guint, guint);

G_END_DECLS
#endif				/* _DOUBLE_LIST_MAIN_OBJECT_H */
