/*  double_list_process_object - object and methods for double list - single process.
    Copyright (C) 2004  Daniele F.

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA  */

/* For bugs or infos please contact me <geekgnele@tin.it> */


#ifndef _DOUBLE_LIST_PROCESS_OBJECT_H
#define _DOUBLE_LIST_PROCESS_OBJECT_H

struct _DoubleListProcessClass {
    GtkVBoxClass parent_class;
};

typedef struct _DoubleListProcessClass DoubleListProcessClass;

struct _DoubleListProcess {
    GtkVBox vbox;
	
	GPtrArray *list_command_name;
    GPtrArray *list_layout2_table;
	
	gboolean autorefresh;
};

typedef struct _DoubleListProcess DoubleListProcess;

#define DOUBLE_LIST_PROCESS_TYPE	(double_list_process_get_type())
#define DOUBLE_LIST_PROCESS(obj) (GTK_CHECK_CAST((obj), double_list_process_get_type(), DoubleListProcess))

/* private */
struct _layout2_elem {
    GtkWidget *scrolledwindow;
    GtkWidget *treeview;
    GtkListStore *liststore;
    GtkTreeIter iter;
    guint lines;
};

typedef struct _layout2_elem layout2_elem;

/* external functions */
GtkWidget *double_list_process_new(void);
GType double_list_process_get_type(void);

/* various functions */
void double_list_process_column_set_visible(DoubleListProcess *, guint, gboolean);
layout2_elem *double_list_process_set_table(DoubleListProcess *);

/* getter functions */
layout2_elem *double_list_process_get_table(DoubleListProcess *, guint);
guint double_list_process_get_number_of_tables(DoubleListProcess *);
guint double_list_process_get_number_lines_for_table(DoubleListProcess *, guint);
gchar *double_list_process_get_name_process(DoubleListProcess *, guint);
GtkListStore *double_list_process_get_liststore_for_table(DoubleListProcess *, guint);
GtkTreeView *double_list_process_get_treeview_for_table(DoubleListProcess *, guint);

#endif				/* _DOUBLE_LIST_PROCESS_OBJECT_H */
