/*  query_editor - Make window for query editing.
    Copyright (C) 2004  Daniele F.

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA  */

/* For bugs or infos please contact me <geekgnele@tin.it> */



#ifndef _QUERY_EDITOR_H
#define _QUERY_EDITOR_H

/* MACRO FUNCTIONS */
#define WARNING_DIALOG(A,B)   GtkWidget *warn_dialog = gtk_message_dialog_new(GTK_WINDOW((B)),\
					    	GTK_DIALOG_DESTROY_WITH_PARENT,\
					    	GTK_MESSAGE_WARNING,\
					    	GTK_BUTTONS_OK,\
					    	(A),\
					    	NULL);\
							gtk_dialog_run(GTK_DIALOG(warn_dialog));\
    						gtk_widget_destroy(warn_dialog);
						
#define ADD_DIALOG(A)	hbox = gtk_hbox_new (FALSE, 6);\
						gtk_container_set_border_width (GTK_CONTAINER (hbox),12);\
						label = gtk_label_new ((A));\
						pf.entry1 = gtk_entry_new ();\
						gtk_box_pack_start (GTK_BOX(hbox), label, FALSE, FALSE, 0);\
						gtk_box_pack_start (GTK_BOX(hbox), pf.entry1, FALSE, FALSE, 0);\
						gtk_box_pack_start (GTK_BOX(GTK_DIALOG(dialog)->vbox), hbox, FALSE, FALSE, 0);
					
#define FREE_LIST(A)	g_slist_foreach ((A), (GFunc)g_free, NULL);\
						g_slist_free ((A));\
						(A) = NULL;

#define GCONF_PATH_QUERY	"/apps/glsof/queries/"

enum {
	PROCESSES = 0,
	NETWORK,
	IDLN,
	FD,
	DIR,
	PID,
	GPID,
	MENUITEMS
};

/* exported functions */
void make_query_editor (gboolean);
void on_ok_button_clicked (GtkButton *, gpointer);
void on_cancel_button_clicked (GtkButton *, gpointer);
void on_set_query_editor_clicked (GtkButton *, gpointer);
void on_set_refresh_query_clicked (GtkButton *, gpointer);
void on_set_rename_query_clicked (GtkButton *, gpointer);
void on_set_remove_query_clicked (GtkButton *, gpointer);
void make_new_query (void);
/* menu items signals */
void on_new_query_activate (GtkMenuItem *, gpointer);


/* struct for network-data */
struct _nd {
    gchar *host;
    gchar *port;
    gchar *ipv;
    gchar *protocol;
};

typedef struct _nd network_data;

/* struct for directory-data */
struct _dd {
    gchar *path;
    gboolean descent;
};

typedef struct _dd dir_data;

/* struct for query-editor */
struct _query_editor {

    GtkWidget *window;

    /* 'Main' from tab menu */
    GtkWidget *add_button;
    GtkWidget *modify_button;
    GtkWidget *remove_button;
    GtkWidget *notebook_lists_container;	/* lists container */
    GtkWidget *scrolledwindow[MENUITEMS];	/* scrolled windows for liststores */
    GtkWidget *cb_active[MENUITEMS];
	GtkWidget *cb_exclude_fd;	/* this widget exclude all FDs in list */
    GtkListStore *liststore[MENUITEMS];	/* liststores */
	GSList *list[MENUITEMS];	/* lists */
    GtkTreeIter iter_selected_row;

    /* 'Others' from tab menu */
    GtkWidget *id_radio;
    GtkWidget *login_radio;
    GtkWidget *offset_radio;
    GtkWidget *size_radio;
    GtkWidget *and_check;
    GtkWidget *hideglsof_check;
    GtkWidget *ipform_check;
    GtkWidget *nfs_check;
    GtkWidget *portnumbers_check;
    GtkWidget *unixsockets_check;
    GtkWidget *timeout_check;
    GtkWidget *timeout_entry;
    GtkWidget *avoid_check;
    GtkWidget *nlinks_check;
    GtkWidget *nlinks_entry;

    guint selected;	/* selected list */

    /* dialog widgets */
    GtkWidget *entry1;
    GtkWidget *entry2;
    GtkWidget *combobox1;
    GtkWidget *combobox2;
    GtkWidget *check1;
	
	/* remove dialog active */
	gboolean modify_dialog_active;
    
    /* name of query */
    gchar *gconf_query_basename;
};

typedef struct _query_editor query_editor;

#endif				/* _QUERY_EDITOR_H */
